
#define GO_LEFT 'a'
#define GO_RIGHT 'd'
#define GO_FORWARD 'w'
#define GO_BACK 's'
#define STOP 'x'

// connect motor controller pins to Arduino digital pins
//Please note: These pin numbers will be fifferent if using an alternative motor driver
// motor one
int enA = 9;
int in1 = 7;
int in2 = 6;
// motor two
int enB = 3;
int in3 = 5;
int in4 = 4;

void setup() {
pinMode(enA, OUTPUT);
pinMode(in1, OUTPUT);
pinMode(in2, OUTPUT);
pinMode(enB, OUTPUT);
pinMode(in3, OUTPUT);
pinMode(in4, OUTPUT);
Serial.begin(9600);//start Serial communication at a rate of 9600 baud
Serial.println("type: 'w' forward, 's' back, 'a' left, 'd' right, 'x' stop");
}

void loop() {
if(Serial.available()) {
char data = (char)Serial.read();
switch(data) {
  case GO_FORWARD:
    goForward();
    Serial.println("Motors Forward");    
    break; 
  case GO_BACK:
    goBackward();
    Serial.println("Motors Backward");    
    break;
  case GO_LEFT:
    goLeft();
    Serial.println("Motors Left");    
    break;
  case GO_RIGHT:
    goRight();
    Serial.println("Motors Right");    
    break;
  case STOP:
    allOff();
    break;
}
}
}

void allOff()
{
  digitalWrite(in1, LOW);
  digitalWrite(in2, LOW);
  digitalWrite(in3, LOW);
  digitalWrite(in4, LOW);
}
 
void goForward()
{
  digitalWrite(in1, HIGH);
  digitalWrite(in2, LOW);
  analogWrite(enA, 255);
  digitalWrite(in3, HIGH);
  digitalWrite(in4, LOW);
  analogWrite(enB, 255);
}
  
  void goBackward()
{ 
  digitalWrite(in1, LOW);
  digitalWrite(in2, HIGH);
  analogWrite(enA, 200);
  digitalWrite(in3, LOW);
  digitalWrite(in4, HIGH);
  analogWrite(enB, 200);
}
  
  void goRight()
{
  digitalWrite(in1, LOW);
  digitalWrite(in2, HIGH);
  analogWrite(enA, 200);
  digitalWrite(in3, HIGH);
  digitalWrite(in4, LOW);
  analogWrite(enB, 200);
}
  
  void goLeft()
{
  digitalWrite(in1, HIGH);
  digitalWrite(in2, LOW);
  analogWrite(enA, 200);
  digitalWrite(in3, LOW);
  digitalWrite(in4, HIGH);
  analogWrite(enB, 200);
}
