#include <Hbridge.h>

//Pin number order (In1,In2,In3,In4,EnA,EnB)
//Please note: These pin numbers will differ if using an alternative motor driver
Hbridge myMotors1(7,6,5,4,9,3);

const int trigPin = A0; // sensor triger pin - use this for A0 pin sensor
const int echoPin = A1; // sensor echo pin - use this for A1 pin sensor

void setup() {
Serial.begin(9600);

}

void loop() {
 int cm; // variable to hold the calculated distance of object

  //cm = Ping3Pin(trigPin);// comment out this line if using a 4 pin sensor
cm = Ping4Pin(trigPin, echoPin);// comment out this line if using a 3 pin sensor
Serial.print("Distance = ");
Serial.println(cm);

if (cm <= 20){ // if the object is within 20 cm of an object
  myMotors1.goBackward();
  Serial.println("Back");
  delay(500);
  myMotors1.goLeft();
   Serial.println("Left");
  delay(250);
  myMotors1.goForward();
   Serial.println("Forward");
}
else {
  myMotors1.goForward();
}
}

// use this function if using a 3 pin sensor
 int Ping3Pin(int trig)
{
   // The PING))) is triggered by a HIGH pulse of 2 or more microseconds.
  // Give a short LOW pulse beforehand to ensure a clean HIGH pulse:
  pinMode(trig, OUTPUT); // define pin as output
  digitalWrite(trig, LOW); // a LOW pulse first to ensure a clean HIGH pulse
  delayMicroseconds(2); // a short delay
  digitalWrite(trig, HIGH); // send a HIGH trigger pulse
  delayMicroseconds(5); // duration of trigger pulse
  digitalWrite(trig, LOW); // a LOW pulse to turn off trigger
  pinMode(trig, INPUT); // change the pin to an input
  long pingTime = pulseIn(trig, HIGH); // receive the echo signal
  int distance = (pingTime / 29) / 2; // convert the data to cm
  return distance; // return the result
}

// use this function if using a 4 pin sensor
int Ping4Pin(int trig, int echo){
  pinMode(trig, OUTPUT); // define trig pin as output
  pinMode(echo, INPUT); // define echo pin as input
  digitalWrite(trig, LOW); // a LOW pulse first to ensure a clean HIGH pulse
  delayMicroseconds(2); // a short delay
  digitalWrite(trig, HIGH); // send a HIGH trigger pulse
  delayMicroseconds(5); // duration of trigger pulse
  digitalWrite(trig, LOW); // a LOW pulse to turn off trigger
  long pingTime = pulseIn(echo, HIGH); // receive the echo signal
  int distance = (pingTime / 29) / 2; // convert the data to cm
  return distance; // return the result
}
