/*
  Hbridge.cpp - Library for using the L298N H-bridge module.
  Created by Seven Vinton April 2017.
  Released into the public domain.
*/

#include "Arduino.h"
#include "Hbridge.h"

Hbridge::Hbridge(int in1, int in2, int in3, int in4, int enA, int enB)
{
  pinMode(in1, OUTPUT);
  pinMode(in2, OUTPUT);
  pinMode(in3, OUTPUT);
  pinMode(in4, OUTPUT);
  pinMode(enA, OUTPUT);
  pinMode(enB, OUTPUT);
  _in1 = in1;
  _in2 = in2;
  _in3 = in3;
  _in4 = in4;
  _enA = enA;
  _enB = enB;
}

void Hbridge::allOff()
{
  digitalWrite(_in1, LOW);
  digitalWrite(_in2, LOW);
  digitalWrite(_in3, LOW);
  digitalWrite(_in4, LOW);
}

void Hbridge::goForward()
{
  digitalWrite(_in1, HIGH);
  digitalWrite(_in2, LOW);
  analogWrite(_enA, 255);
  digitalWrite(_in3, HIGH);
  digitalWrite(_in4, LOW);
  analogWrite(_enB, 255);
}

void Hbridge::goBackward()
{
  digitalWrite(_in1,    );
  digitalWrite(_in2,    );
  analogWrite(_enA, 200);
  digitalWrite(_in3,    );
  digitalWrite(_in4,    );
  analogWrite(_enB, 200);
}

void Hbridge::goRight()
{
  digitalWrite(_in1,    );
  digitalWrite(_in2,    );
  analogWrite(_enA, 200);
  digitalWrite(_in3,    );
  digitalWrite(_in4,    );
  analogWrite(_enB, 200);
}

void Hbridge::goLeft()
{
  digitalWrite(_in1,    );
  digitalWrite(_in2,    );
  analogWrite(_enA, 200);
  digitalWrite(_in3,    );
  digitalWrite(_in4,    );
  analogWrite(_enB, 200);
}