/*
* A sketch to contol the speed of a DC motor
* commands from serial port control motor speed
* digits '0' through '9' are valid where '0' is off, '9' is max speed
* This sketch is in the public domain
*/
int motorPin = 9; // the pin connected to the base leg of the transistor (motor pin)
void setup()
{
Serial.begin(9600); // begin serial communication
Serial.println("Please enter a number between 0 and 9 to change the motor speed from 'Stop' to 'Full'");
}
void loop(){
  //if serial communication is available
if ( Serial.available()) {
char ch = Serial.read();
if(ch >= '0' && ch <= '9') // is ch a number between 0 and 9?
{
int revSpeed = map(ch, '0', '9', 0, 255); // map the speed of the motor from (0-9) to (0-255)
analogWrite(motorPin, revSpeed); // send this as PWM pulse to the motorPin
Serial.print("The speed of the motor is "); // print the speed to the serial monitor
Serial.println(revSpeed);
}
else{
// if the user inputs and unexpected character, print the error message
Serial.print("Unexpected character ");
Serial.println(ch);
}
}
}
