/* 
 * A sketch to activate a motor's speed according to distance measured by a ping sensor
 * this sketch uses code modified from the Ping))) Sensor sketch created by:
 * David A. Mellis 3 Nov 2008
 * modified by Tom Igoe 30 Aug 2011
 * This examples provides two functions: one for a 3 pin sensor and the other for a 4 pin sensor
 * This example was created by Seven Vinton 7 April 2017
 * This example code is in the public domain
 */
int motorPin = 9; // motor driver is connected to pin 9
int trigPin = A0; // sensor triger pin - use this for A0 pin sensor
int echoPin = A1; // sensor echo pin - use this for A1 pin sensor

void setup() {

  Serial.begin(9600);  // initialize serial communication:
}

void loop() {
  long duration; // variable to hold the echo time
  int cm; // variable to hold the calculated distance of object
  int revSpeed;
  //cm = Ping3Pin(trigPin, duration);// comment out this line if using a 4 pin sensor
cm = Ping4Pin(trigPin, echoPin,duration);// comment out this line if using a 3 pin sensor

if (cm > 5 && cm > 100){ // if the object is within range (change this to suit)
  revSpeed = map(cm, 5, 100, 50, 255); // converts data range from sensor from 5 -> 100 to 50 -> 255
  analogWrite(motorPin, revSpeed); // drive the motor at the converted speed
  delay(500);
  }
  
else { 
    analogWrite(motorPin, 0); // else set the motor to zero

  revSpeed = 0;
  }
  
  Serial.print(cm); // print the data to the Serial monitor
  Serial.print("cm");
  Serial.println();
  Serial.print("motor speed is: ");
  Serial.println(revSpeed);
  delay(50); // a short delay
}

// use this function if using a 3 pin sensor
 int Ping3Pin(int trig, int pingTime)
{
   // The PING))) is triggered by a HIGH pulse of 2 or more microseconds.
  // Give a short LOW pulse beforehand to ensure a clean HIGH pulse:
  pinMode(trig, OUTPUT); // define pin as output
  digitalWrite(trig, LOW); // a LOW pulse first to ensure a clean HIGH pulse
  delayMicroseconds(2); // a short delay
  digitalWrite(trig, HIGH); // send a HIGH trigger pulse
  delayMicroseconds(5); // duration of trigger pulse
  digitalWrite(trig, LOW); // a LOW pulse to turn off trigger
  pinMode(trig, INPUT); // change the pin to an input
  pingTime = pulseIn(trig, HIGH); // receive the echo signal
  int distance = (pingTime / 29) / 2; // convert the data to cm
  return distance; // return the result
}

// use this function if using a 4 pin sensor
int Ping4Pin(int trig, int echo, int pingTime){
  pinMode(trig, OUTPUT); // define trig pin as output
  pinMode(echo, INPUT); // define echo pin as input
  digitalWrite(trig, LOW); // a LOW pulse first to ensure a clean HIGH pulse
  delayMicroseconds(2); // a short delay
  digitalWrite(trig, HIGH); // send a HIGH trigger pulse
  delayMicroseconds(5); // duration of trigger pulse
  digitalWrite(trig, LOW); // a LOW pulse to turn off trigger
  pingTime = pulseIn(echo, HIGH); // receive the echo signal
  int distance = (pingTime / 29) / 2; // convert the data to cm
  return distance; // return the result
}

 // The speed of sound is 340 m/s or 29 microseconds per centimeter.
 // The ping travels out and back, so to find the distance of the
 // object we take half of the distance travelled.
